package com.goafanti.common.dao;

import com.goafanti.common.model.TaskScore;
import com.goafanti.order.bo.TaskScore.InputTaskScore;
import com.goafanti.order.bo.TaskScore.OutAdminTaskScore;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 项目评分列表(TaskScore)表数据库访问层
 *
 * @author makejava
 * @since 2024-10-15 10:49:43
 */
public interface TaskScoreMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TaskScore queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param taskScore 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<TaskScore> findTaskScoreList(TaskScore taskScore, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param taskScore 查询条件
     * @return 总行数
     */
    int findTaskScoreCount(TaskScore taskScore);

    /**
     * 新增数据
     *
     * @param taskScore 实例对象
     * @return 影响行数
     */
    int insert(TaskScore taskScore);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TaskScore> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TaskScore> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TaskScore> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TaskScore> entities);

    /**
     * 修改数据
     *
     * @param taskScore 实例对象
     * @return 影响行数
     */
    int update(TaskScore taskScore);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    TaskScore queryByTid(Integer tid);

    List<OutAdminTaskScore> findAdminTaskScoreList(InputTaskScore in);

    List<TaskScore> selectRemarkByAid(String id);
}

